'''
Created on 03.08.2010

@author: sschneider
'''

def sjoerds(original, prediction):
    pos = {}
    neg = {}
    true_pos = 0
    false_pos = 0
    true_neg = 0
    false_neg = 0
    for a in original:
        if a.temp == 1.0:
            pos[a.at_nr] = a
        else:
            neg[a.at_nr] = a
    for a in prediction:
        if a.temp == 1.0 and a.at_nr in pos:
            true_pos += 1
        elif a.temp == 1.0 and a.at_nr in neg:
            false_pos += 1
        elif a.temp == 0.0 and a.at_nr in neg:
            true_neg += 1
        elif a.temp == 0.0 and a.at_nr in pos:
            false_neg += 1
    acc = float((true_pos+true_neg))/float((true_pos+true_neg+false_pos+false_neg))
    spec = float(true_pos)/float(true_pos+false_pos)
    sens = float(true_pos)/float(true_pos+false_neg)
    return acc, spec, sens
    
    
    


def bindingSiteOverlap(original, prediction):
    true_pos = {}
    for a in original:
        if a.temp == 1.0:
            true_pos[a.at_nr] = a
    count = 0
    for a in prediction:
        if a.temp == 1.0 and a.at_nr in true_pos:
            count += 1
    return float(count)/float(len(true_pos))

def sensitivity(original, prediction, verbose=True):
    true_pos = {}
    for a in original:
        if a.temp == 1.0:
            true_pos[a.at_nr] = a
    true_pos_count = 0
    false_neg_count = 0    
    for a in prediction:
        if a.temp == 1.0 and a.at_nr in true_pos:            
            true_pos_count += 1
        if a.temp == 0.0 and a.at_nr in true_pos:
            false_neg_count += 1    
    sens = float(true_pos_count) / (float(true_pos_count) + float(false_neg_count))
    if verbose == True:
        print "Sensitvity: " + str(sens)
    return sens

def specificity(original, prediction, verbose=True):
    true_false = {}
    for a in original:
        if a.temp == 0.0:
            true_false[a.at_nr] = a
    true_false_count = 0
    false_pos_count = 0
    for a in prediction:
        if a.temp == 0.0 and a.at_nr in true_false:
            true_false_count += 1
        if a.temp == 1.0 and a.at_nr in true_false:
            false_pos_count += 1
    spec = float(true_false_count) / (float(true_false_count) + float(false_pos_count))
    if verbose == True:
        print "Specificity: " + str(spec)
    return spec

def PPV(original, prediction, verbose=True):
    true_pos = {}
    for a in original:
        if a.temp == 1.0:
            true_pos[a.at_nr] = a
    true_pos_count = 0
    false_pos_count = 0
    for a in prediction:
        if a.temp == 1.0:
            if a.at_nr in true_pos:
                true_pos_count += 1
            if a.at_nr not in true_pos:
                false_pos_count += 1
    ppv = float(true_pos_count)/(float(true_pos_count)+float(false_pos_count))
    if verbose == True:
        print "Positive predictive value: "+str(ppv)
    return ppv

def NPV(original, prediction, verbose=True):
    true_neg = {}
    for a in original:
        if a.temp == 0.0:
            true_neg[a.at_nr] = a
    true_neg_count = 0
    false_neg_count = 0
    for a in prediction:
        if a.temp == 0.0:
            if a.at_nr in true_neg:
                true_neg_count += 1
            if a.at_nr not in true_neg:
                false_neg_count += 1
    npv = float(true_neg_count)/(float(true_neg_count)+float(false_neg_count))
    if verbose == True:
        print "Negative predictive value: "+str(npv)
    return npv