'''
Created on 27.05.2010

@author: sschneider
'''
from IO import PDBReader

def createSolvDat():
    sol = file("solv.dat", "w")
    s_tmp = []
    s_tmp.append([1, 0.001, 0.000, "CA"])
    s_tmp.append([2, 1.900, 0.026, "ALA"])
    s_tmp.append([3, 1.950, 0.030, "ARG1"])
    s_tmp.append([4, 2.200, -0.136, "ARG2"])
    s_tmp.append([5, 2.100, -0.009, "ASN"])
    s_tmp.append([6, 2.100, -0.123, "ASP"])
    s_tmp.append([7, 2.150, 0.038, "CYS"])
    s_tmp.append([8, 2.000, 0.050, "GLN1"])
    s_tmp.append([9, 2.000, -0.008, "GLN2"])
    s_tmp.append([10, 2.000, 0.050, "GLU1"])
    s_tmp.append([11, 2.000, -0.115, "GLU2"])
    s_tmp.append([12, 2.000, -0.010, "HIS1"])
    s_tmp.append([13, 1.900, -0.017, "HIS2"])
    s_tmp.append([14, 2.200, 0.075, "ILE"])
    s_tmp.append([15, 2.200, 0.079, "LEU"])
    s_tmp.append([16, 2.000, 0.030, "LYS1"])
    s_tmp.append([17, 1.900, -0.154, "LYS2"])
    s_tmp.append([18, 1.990, 0.060, "MET1"])
    s_tmp.append([19, 2.100, 0.070, "MET2"])
    s_tmp.append([20, 2.100, 0.050, "PHE1"])
    s_tmp.append([21, 2.200, 0.088, "PHE2"])
    s_tmp.append([22, 1.900, 0.068, "PRO"])
    s_tmp.append([23, 1.900, 0.007, "SER"])
    s_tmp.append([24, 1.900, 0.031, "THR"])
    s_tmp.append([25, 1.990, 0.040, "TRP1"])
    s_tmp.append([26, 2.200, 0.105, "TRP2"])
    s_tmp.append([27, 2.100, 0.050, "TYR1"])
    s_tmp.append([28, 2.200, 0.062, "TYR2"])
    s_tmp.append([29, 1.990, 0.073, "VAL"])
    s_tmp.append([30, 1.900, -0.020, "N"])
    s_tmp.append([31, 1.900, -0.020, "O"])
    for s in s_tmp:
        sol.write("{0:>5}  {1:.3f} {2:>6.3f}  {3:4} {4}".format(s[0], s[1], s[2], s[3], "\n"))    
    sol.close()
    
def createSolvDatNew():
    sol = file("solv.dat", "w")
    sol.write("""        1  0.001  0.000  CA
        2  1.900  0.026  ALA
        3  1.950  0.030  ARG1
        4  2.200 -0.136  ARG2
        5  2.100 -0.009  ASN
        6  2.100 -0.123  ASP
        7  2.150  0.038  CYS
        8  2.000  0.050  GLN1
        9  2.000 -0.008  GLN2
       10  2.000  0.050  GLU1
       11  2.000 -0.115  GLU2
       12  2.000 -0.010  HIS1
       13  1.900 -0.017  HIS2
       14  2.200  0.075  ILE
       15  2.200  0.079  LEU
       16  2.000  0.030  LYS1
       17  1.900 -0.154  LYS2
       18  1.990  0.060  MET1 
       19  2.100  0.070  MET2 
       20  2.100  0.050  PHE1
       21  2.200  0.088  PHE2
       22  1.900  0.068  PRO
       23  1.900  0.007  SER
       24  1.900  0.031  THR
       25  1.990  0.040  TRP1
       26  2.200  0.105  TRP2
       27  2.100  0.050  TYR1
       28  2.200  0.062  TYR2
       29  1.990  0.073  VAL
       30  1.900 -0.020  N
       31  1.900 -0.020  O""")

    
def createTleapForAPBS(pdb):
    tleap = file(pdb + ".tleap", "w")
    tleap.write("t = loadpdb " + pdb + ".pdb")
    tleap.write("\n")
    tleap.write("setbox t vdw")
    tleap.write("\n")
    tleap.write("quit")
    tleap.write("\n")
    tleap.close()

"""
TESTVERSION!!!!!
"""
def createTleapForAmberPB(pdb, save=False):
    tleap = file(pdb + ".tleap", "w")
    tleap.write("source leaprc.ff03.r1 \n")
#    tleap.write("set default PBradii mbondi2 \n")
    tleap.write("t = loadpdb " + pdb + ".pdb")
    tleap.write("\n")
#    tleap.write("setbox t vdw")
#    tleap.write("\n")
    if save:
        tleap.write("savepdb t " + pdb + ".pdb \n")
    tleap.write("saveamberparm t " + pdb + ".top " + pdb + ".crd")
    tleap.write("\n")
    tleap.write("quit")
    tleap.write("\n")
    tleap.close()

def createTleapForAmberGB(pdb, save=False):
    tleap = file(pdb + ".tleap", "w")
    tleap.write("source leaprc.ff03.r1 \n")
    tleap.write("set default PBradii mbondi2 \n")
    tleap.write("t = loadpdb " + pdb + ".pdb")    
    tleap.write("\n")
    #tleap.write("check t \n")        
    tleap.write("saveamberparm t " + pdb + ".top " + pdb + ".crd \n")
    if save == True:
        tleap.write("savepdb t " + pdb + ".pdb \n")
#    tleap.write("\n")
    tleap.write("quit")
    tleap.write("\n")
    tleap.close()

def cleanFileAfterConversion(pdb):
    leap = open("leap.log").readlines()
    res = {}
    for line in leap:
        ele = line.split()
        if len(ele) == 0:
            continue
        if ele[0] == "Created" and ele[1] == "a" and ele[2] == "new" and ele[3] == "atom":
            tmp = ele[5]
            r = ele[9].split(">")[0]
            res[r] = tmp
    p = open(pdb + ".pdb")
    lines = p.readlines()
    p.close()
    out = file(pdb + ".pdb", "wb")
    for line in lines:
        ele = line.split()
        if len(ele) < 5:
            continue
        if ele[4] in res and ele[2] == res[ele[4]]:
            continue
        out.write(line)
            
    
    
    



    
def createTleapForStructureRefinement(pdb):
    tleap = file(pdb + "ref.tleap", "w")
    tleap.write("t = loadpdb " + pdb + ".pdb")
    tleap.write("\n")    
    tleap.write("savepdb t " + pdb + ".pdb")
    tleap.write("\n")
    tleap.write("quit")
    tleap.write("\n")
    tleap.close()

    
def createInputFileForAPBS(pdb, box):
    inFile = file(pdb + ".in", "w")
    #read in part
    inFile.write("read \n")
    inFile.write("    mol pqr " + pdb + ".pqr \n")
    inFile.write("end \n")
    # first part
    inFile.write("elec \n")
    inFile.write("    mg-auto \n")
    inFile.write("    dime 129 129 129 \n")
    inFile.write("    cglen " + str(box[1][0]) + " " + str(box[1][1]) + " " + str(box[1][2]) + "\n")
    inFile.write("    fglen " + str(box[2][0]) + " " + str(box[2][1]) + " " + str(box[2][2]) + "\n")
    inFile.write("    cgcent mol 1 \n")
    inFile.write("    fgcent mol 1 \n")
    inFile.write("    mol 1 \n")
    inFile.write("    lpbe \n")
    inFile.write("    bcfl sdh \n")
    inFile.write("    pdie 10.0000 \n")
    inFile.write("    sdie 80.00 \n")
    inFile.write("    srfm smol \n")
    inFile.write("    chgm spl2 \n")
    inFile.write("    sdens 10.00 \n")
    inFile.write("    srad 1.40 \n")
    inFile.write("    swin 0.30 \n")
    inFile.write("    temp 298.15 \n")
    inFile.write("    calcenergy total \n")
    inFile.write("    calcforce no \n")    
    inFile.write("end \n")
    #second part
    inFile.write("elec \n")
    inFile.write("    mg-auto \n")
    inFile.write("    dime 129 129 129 \n")
    inFile.write("    cglen " + str(box[1][0]) + " " + str(box[1][1]) + " " + str(box[1][2]) + "\n")
    inFile.write("    fglen " + str(box[2][0]) + " " + str(box[2][1]) + " " + str(box[2][2]) + "\n")
    inFile.write("    cgcent mol 1 \n")
    inFile.write("    fgcent mol 1 \n")
    inFile.write("    mol 1 \n")
    inFile.write("    lpbe \n")
    inFile.write("    bcfl sdh \n")
    inFile.write("    pdie  10.0000 \n")
    inFile.write("    sdie  2.0000 \n")
    inFile.write("    srfm smol \n")
    inFile.write("    chgm spl2 \n")
    inFile.write("    sdens 10.00 \n")
    inFile.write("    srad 1.40 \n")
    inFile.write("    swin 0.30 \n")
    inFile.write("    temp 298.15 \n")
    inFile.write("    calcenergy total \n")
    inFile.write("    calcforce no \n") 
    inFile.write("end \n")
    inFile.write("print elecEnergy 1 - 2 end \n")
    inFile.write("quit \n")    
    inFile.close() 
    
    
def createReferenceInputFileForAPBS(pdb, box):
    createInputFileForAPBS(pdb, box)

def createTemporaryInputFileForAPBS(pdb, box):
    createInputFileForAPBS(pdb + "_tmp", box)
    
    
def getElecFromAPBS(apbs):
    ap = open(apbs)
    for line in ap.readlines():
        ele = line.split()
        if len(ele) > 0 and ele[0] == "Global" and ele[1] == "net" and ele[2] == "ELEC" and ele[3] == "energy":
            return float(ele[5])
        
def getElecFromGB(gb_file):
    gb = open(gb_file)
    lines = gb.readlines()
    for line in lines:
        ele = line.split()
        if len(ele) != 9:
            continue
        if ele[6] == "EGB":
            return float(ele[8])
    

def getElecFromPB(pb_file):
    pb = open(pb_file)
    lines = pb.readlines()
    for line in lines:
        ele = line.split()
        if len(ele) != 9:
            continue
        if ele[6] == "EPB":
            return float(ele[8])


        
def readInSurfacePoints(surf):
    reader = PDBReader.PDBReader()
    points = reader.readPDB(surf, False)
    count = 1
    for p in points.atoms:
        p.at_nr = count
        count += 1
    return len(points.atoms), points

def getBoxFromLeapLog():
    log = open("leap.log")
    x = 0.0
    y = 0.0
    z = 0.0   
    for line in log.readlines():
        ele = line.split()
        if len(ele) > 0 and ele[0] == "Box" and ele[1] == "dimensions:":
            x = float(ele[2]) 
            y = float(ele[3]) 
            z = float(ele[4])
    return [(x, y, z), (x * 2.0, y * 2.0, z * 2.0), (x + 2.0, y + 2.0, z + 2.0)]
    
