/*
 * atom.cpp
 *
 *  Created on: 19.05.2009
 *      Author: sschneider
 */

#include "Atom.h"
#include <iostream>

using namespace std;


Atom::Atom() {
}

Atom::Atom(int nr, string type, string acid, int acidnr, float x, float y,
		float z, float occ, float temp) {

	this->nr = nr;
	this->type = type;
	this->acid = acid;
	this->acidnr = acidnr;
	this->x = x;
	this->y = y;
	this->z = z;
	this->occ = occ;
	this->temp = temp;
	this->vdw = 0.0;

	if (type.find("H") != string::npos) {
		this->vdw = 1.3;
	} else if (type.find("Cl") != string::npos) {
		this->vdw = 0.0;
	} else if (type.find("Cu") != string::npos) {
		this->vdw = 0.0;
	} else if (type.find("C") != string::npos) {
		this->vdw = 1.7;
	} else if (type.find("N") != string::npos) {
		this->vdw = 1.55; //1.7
	} else if (type.find("O") != string::npos) {
		this->vdw = 1.5; //1.6
	} else if (type.find("F") != string::npos) {
		this->vdw = 0.0;
	} else if (type.find("P") != string::npos) {
		this->vdw = 2.0;
	} else if (type.find("S") != string::npos) {
		this->vdw = 2.0;
	}
}
;

Atom::~Atom() {
	//	/cout << this->type << endl;
}

void Atom::setTempZero() {
	this->temp = 0.0;
}

