'''
Created on 24.04.2012

@author: sschneider
'''
import div
from Structure import Point3D

class Cavity:
    
    def __init__(self):
        self.points = []
        self.center = None
        
    def generateCenter(self):
        x = 0.0
        y = 0.0
        z = 0.0
        for a in self.points:
            x += a.x
            y += a.y
            z += a.z
        x /= float(len(self.points))
        y /= float(len(self.points))
        z /= float(len(self.points))
        self.center = Point3D.Point3D(x, y, z)
         
    def getCenterFromBox(self):
        xh = -10000.0
        yh = -10000.0
        zh = -10000.0
        xl = 10000.0
        yl = 10000.0
        zl = 10000.0
        for a in self.points:
            if a.x > xh:
                xh = a.x
            if a.y > yh:
                yh = a.y
            if a.z > zh:
                zh = a.z
                
            if a.x < xl:
                xl = a.x
            if a.y < yl:
                yl = a.y
            if a.z < zl:
                zl = a.z
        self.center = Point3D.Point3D(xl + (xh - xl) / 2.0, yl + (yh - yl) / 2.0, zl + (zh - zl) / 2.0) 
        
    def getNearestPointToCenter(self):
        nearest = None
        dist = 1000000.0
        for a in self.points:
            d = div.distanceNoSQRT(a, self.center)
            if d < dist:
                nearest = a.copy()
                dist = d
        return nearest