'''
Created on 31.08.2010

@author: sschneider
'''
#from Molecules import PDB_IO, Protein
import copy

def distance(a, b):
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) + (a.z - b.z) * (a.z - b.z)

class cavity:
    
    probes = {}
    
    def __init__(self, nr):
        self.nr = nr
    
    def isIn(self, probe):
        if probe.at_nr in self.probes:
            return True
        elif probe.at_nr not in self.probes:
            return False 
    
    def copy(self):
        new_probes = {}
        new_number = copy.copy(self.nr)
        for k, v in self.probes.iteritems():
            new_probes[copy.copy(k)] = v.copy()
        new_cav = cavity(new_number)
        new_cav.probes = new_probes
        return new_cav
    
    def delMe(self):
        self.probes.clear()
        self.nr = -1
        
    def printMe(self):        
        l = self.probes.keys()
        print "Cavity nr " + str(self.nr) + " has atoms nr: "
        print " ".join(l)
        print "as probes"


neigs = {}
def getNeighbours(all, atoms, dist):
    ret = []
    dd = dist * dist
    for a in all:
        for k, b in atoms.iteritems():
            if k in neigs:
                continue            
            if distance(a, b) <= dd:
                ret.append(b.copy())       
    return ret

"""
WARNING: RECURSION!!!
"""
def getAllNeighbours(aneig, atoms, dist):    
    if len(aneig) > 0:        
        res = []                
        tmpNeighbours = getNeighbours(aneig, atoms, dist)            
        for neighbour in tmpNeighbours:            
            if neighbour.at_nr not in neigs:                
                neigs[neighbour.at_nr] = neighbour.copy()
                res.append(neighbour.copy())     
        aneig = getAllNeighbours(res, atoms, dist)
        
def filterProbesOutsideCavity(sps, nr_of_probes, dist_to_neig):    
    cavities = {}
    cav_count = 1
    for i in range(len(sps.atoms)):
        sps.atoms[i].at_nr = i + 1
    probes = {}
    for a in sps.atoms:
        probes[a.at_nr] = a.copy()
    while len(probes) > 0:
        keys = probes.keys()
        p = probes[keys[0]]
        tmp_cav = cavity(cav_count)    
        tmp_list = []
        tmp_list.append(p)
        neigs[p.at_nr] = p.copy()    
        getAllNeighbours(tmp_list, probes, dist_to_neig)
        for k, v in neigs.iteritems():
            if tmp_cav.isIn(v) == False:
                tmp_cav.probes[v.at_nr] = v.copy()
        neigs.clear()
        for k, v in tmp_cav.probes.iteritems():
            del probes[k]
        cavities[cav_count] = tmp_cav.copy()
        tmp_cav.delMe()        
        cav_count += 1
        while len(tmp_list) > 0:
            del tmp_list[0]
    leftOver = []
    for cav_nr, cav in cavities.iteritems():
        if len(cav.probes) < nr_of_probes:
            continue
        for at_nr_kk, probe in cav.probes.iteritems():
            probe.res_nr = cav_nr             
            leftOver.append(probe)            
    return leftOver
    
