'''
Created on 09.02.2012

@author: sschneider
'''
import div, math
from IO import PDBReader, PDBWriter
import CavityProbeIdentifier
from Methods import Data_Handling
from Structure import Protein, Atom


def calcSmallProbes(pdb, srad=1.4, fac=1.0):    
    print "settings"   
    nphi = 30;
    fac2 = fac * fac
    ncosth = 20;    
    print "nphi", nphi
    print "ncosth", ncosth
    print "probesize", srad    
    natoms = len(pdb.atoms)        
    csth = []
    snth = []
    phgh = []
    cos_phigh = []
    sin_phigh = [] 
    neigh = []   
    sasa = []            
    for ik in range(ncosth):        
        csth.append(-1.0 + ((ik + 1) - 0.5) * (2.0 / (ncosth)))
        snth.append(math.sqrt(1.0 - csth[ik] * csth[ik]))    
    for ik in range(nphi):
        phgh.append(2.0 * math.pi * (ik) / (nphi));    
    for kk in range(nphi):
        cos_phigh.append(math.cos(phgh[kk]))
        sin_phigh.append(math.sin(phgh[kk]))
    
    for i in range(natoms):        
        neigh[:] = []                  
        for j in range(natoms):
            if j == i:
                continue        
            if div.distance(pdb.atoms[i], pdb.atoms[j]) <= (pdb.atoms[i].vdw + pdb.atoms[j].vdw + 2.0 * srad):
                neigh.append(pdb.atoms[j])    
        for jj in range(ncosth):
            costh = csth[jj];
            sinth = snth[jj];
            for kk in range(nphi):                
                xp = (pdb.atoms[i].vdw + srad) * sinth * cos_phigh[kk];
                yp = (pdb.atoms[i].vdw + srad) * sinth * sin_phigh[kk];
                zp = (pdb.atoms[i].vdw + srad) * costh;
                ll = 0;
                coverd = False;
                while (not coverd and ll < len(neigh)):
                    if (pow((pdb.atoms[i].x + xp - neigh[ll].x), 2) + pow((pdb.atoms[i].y + yp
                            - neigh[ll].y), 2) + pow((pdb.atoms[i].z + zp - neigh[ll].z), 2)) < pow((neigh[ll].vdw + srad), 2):                        
                        coverd = True;                    
                    ll += 1;                
                if (coverd == False):
#                    tmp_p = Point3D.Point3D(pdb.atoms[i].x + xp, pdb.atoms[i].y + yp, pdb.atoms[i].z + zp)
                    tmp_p = Atom.Atom(1, "H", "", "", "", "SPS", "", 1, "", pdb.atoms[i].x + xp, pdb.atoms[i].y + yp, pdb.atoms[i].z + zp, 0.0, 0.0, "", "", "")
                    tmp_bool = False
                    for a in sasa:
                        if div.distanceNoSQRT(a, tmp_p) < fac2:
                            tmp_bool = True
                            break
                    if tmp_bool == False:                                   
                        sasa.append(tmp_p.copy())                                                 
    return sasa

def isIn(listOfProbes, probe):
    for a in listOfProbes:
        if a.at_nr == probe.at_nr:
            return True
    return False

def getCavityProbes(prot, sp, bp, cs1):    
    reader = PDBReader.PDBReader()    
    pdb = reader.readPDB(prot + ".pdb", False)
    print "calc small probes"
    smallProbes = calcSmallProbes(pdb, sp, sp - sp * 0.2)
    PDBWriter.PDBWriter().writePDB("small.points", Protein.Protein(smallProbes), False)
    print "calc big probes"
    largeProbes = calcSmallProbes(pdb, bp, 2.0)
    PDBWriter.PDBWriter().writePDB("large.points", Protein.Protein(largeProbes), False)
    nr = 1
    print "filter probes"
    for s in smallProbes:
        s.at_nr = nr
        nr += 1
    
    new_smallProbes = []
    for s in smallProbes:
        hitted = False
        for b in largeProbes:
            if div.distance(s, b) < sp + bp:
                hitted = True
                break
        if not hitted:
            new_smallProbes.append(s.copy())
    print "nr of raw probes", len(new_smallProbes)
    PDBWriter.PDBWriter().writePDB("raw.points", Protein.Protein(new_smallProbes), False)
     
    distFac = sp
    print "start clustering of", len(new_smallProbes), "probes"    
    new_smallProbes_clustered = (CavityProbeIdentifier.filterProbesOutsideCavity(Protein.Protein(new_smallProbes), int(cs1), distFac))
    print "clustering left", len(new_smallProbes_clustered), "probes"
    PDBWriter.PDBWriter().writePDB("clustered.points", Protein.Protein(new_smallProbes_clustered), False)
    finalProbes = [s.copy() for s in new_smallProbes_clustered]
    print "initial size", len(finalProbes)
    for s in new_smallProbes_clustered:
        for n in smallProbes:
            if not isIn(finalProbes, n):
                if div.distance(s, n) < (sp * 2.2):
                    finalProbes.append(n.copy())
    print "extended size", len(finalProbes)
    PDBWriter.PDBWriter().writePDB("finalsurface.points", Protein.Protein(finalProbes), False)
    
    sps = Protein.Protein(finalProbes)
    print "raw", len(sps.atoms)
    leftOver = CavityProbeIdentifier.filterProbesOutsideCavity(Protein.Protein(finalProbes), int(cs1), distFac)
    writer = PDBWriter.PDBWriter()
    print len(leftOver)
    if len(leftOver) < cs1:
        allProbes = CavityProbeIdentifier.filterProbesOutsideCavity(sps.copy(), cs1, 2.0 * distFac)
        if len(allProbes) < cs1:
            allProbes = CavityProbeIdentifier.filterProbesOutsideCavity(Protein.Protein(new_smallProbes), int(cs1 / 2.0), 4.0 * distFac)
        writer.writeSP(prot + ".spt", allProbes)
        print "miss -->", len(allProbes)
    else:            
        writer.writeSP(prot + ".spt", leftOver)
        print
    return Data_Handling.readInSurfacePoints(prot + ".spt")
    
