'''
Created on 18.11.2010

@author: sschneider
'''
import math
from IO import PDBReader, PDBWriter
from Structure import  Protein
from SurfPointCreator import CavityProbeIdentifier

def prepareLigsiteResults(name, spacing, proname):
    ready = PDBReader.PDBReader()
    ligs = ready.readPDB(name)
    for a in ligs.atoms:
        a.temp = 0.0
    print "read " + str(len(ligs.atoms)) + " nr of possible surface points"
    for i in range(len(ligs.atoms)):
        if ligs.atoms[i].temp == 1.0: continue
        for j in range(len(ligs.atoms)):
            if ligs.atoms[j].temp == 1.0: continue
            if i == j: continue
            if ligs.atoms[i].distToOtherNoSqrt(ligs.atoms[j]) < spacing * spacing:
                ligs.atoms[j].temp = 1.0
                
    new_atoms = []
    for a in ligs.atoms:
        if a.temp == 0.0:
            new_atoms.append(a.copy())
    
    
    newer_atoms = []
    prot = ready.readPDB(proname)
    for a in new_atoms:
        nearestDist = 1000.0
        for b in prot.atoms:            
            d = a.distToOtherNoSqrt(b) - b.vdw 
            if d < nearestDist:
                nearestDist = d
        try:
            dd = math.sqrt(nearestDist)
            if dd >= 1.0 and dd <= 3.8:
                a.occ = dd
                newer_atoms.append(a)
        except:
            a.occ = 2.0
    #print str(len(new_atoms)) + " surface points left... with cut out distance " + str(spacing)
    writer = PDBWriter.PDBWriter()
    writer.writePDB(name.split(".")[0]+"_raw.spt", Protein.Protein(newer_atoms), False)    
    return CavityProbeIdentifier.filterProbesOutsideCavity(ready.readPDB(name.split(".")[0]+"_raw.spt", False), 4, 1.6)
    
