/*
 * SurfacePointGenerator.cpp
 *
 *  Created on: 19.10.2010
 *      Author: sschneider
 */

#include "SurfacePointGenerator.h"
#include <math.h>
#include <iostream>
#include "Molecules/Atom.h"
#include <vector>

SurfacePointGenerator::SurfacePointGenerator(Protein average, int nphi,
		int ncosth) {
	std::cout << "precalculations..." << std::endl;
	this->nphi = nphi;
	this-> ncosth = ncosth;
	for (ik = 0; ik < ncosth; ik++) {
		csth[ik] = -1.0 + ((double) (ik + 1) - 0.5) * (2.0 / (double) (ncosth));
		snth[ik] = sqrt(1.0 - csth[ik] * csth[ik]);
	}
	for (ik = 0; ik < nphi; ik++) {
		phgh[ik] = (2.0 * pi * (double) (ik) / (double) (nphi));
	}
	for (kk = 0; kk < nphi; kk++) {
		cos_phigh[kk] = cos(phgh[kk]);
		sin_phigh[kk] = sin(phgh[kk]);
	}
	this->natoms = average.atoms.size();
	cout << "Template consists of " << natoms << endl;
	for (unsigned int i = 0; i < average.atoms.size(); i++) {
		xcrd[i] = average.atoms[i].x;
		ycrd[i] = average.atoms[i].y;
		zcrd[i] = average.atoms[i].z;
		ie[i] = average.atoms[i].acidnr;
		radi[i] = average.atoms[i].vdw;
	}

}

SurfacePointGenerator::~SurfacePointGenerator() {
	// TODO Auto-generated destructor stub
}

float distance(Point a, Point b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) + (a.z - b.z)
			* (a.z - b.z);
}

double myround(double zahl, int stellen) {
	double order = pow(10.0, stellen);
	return (int) (zahl * order + (zahl > 0 ? 0.5 : -0.5)) / order;
}

vector<Point> SurfacePointGenerator::calcVolume(float srad, float fac) {
	//	int nphi = 55;
	//	int ncosth = 40;
	cout << "shell " << srad << endl;
	vector<Point> sps;
	float fac2 = fac * fac;
	for (ii = 0; ii < this->natoms; ii++) {

		numneh = 0;
		for (jj = 0; jj < this->natoms; jj++) {// start neighbouring
			if (jj == ii)
				continue;
			ccdist = (xcrd[ii] - xcrd[jj]) * (xcrd[ii] - xcrd[jj]) + (ycrd[ii]
					- ycrd[jj]) * (ycrd[ii] - ycrd[jj]) + (zcrd[ii] - zcrd[jj])
					* (zcrd[ii] - zcrd[jj]);
			rr = (radi[ii] + radi[jj] + 2.0 * srad) * (radi[ii] + radi[jj]
					+ 2.0 * srad);
			if (ccdist <= rr) {
				neigh[numneh] = jj;
				++numneh;
			}
		}// end neighbouring

		for (jj = 0; jj < this->ncosth; jj++) {
			costh = csth[jj];
			sinth = snth[jj];
			for (kk = 0; kk < this->nphi; kk++) {
//				phigh = phgh[kk];
				xp = (radi[ii] + srad) * sinth * cos_phigh[kk];
				yp = (radi[ii] + srad) * sinth * sin_phigh[kk];
				zp = (radi[ii] + srad) * costh;
				ll = 0;
				coverd = false;
				while (coverd == false and ll < numneh) {
					if ((xcrd[ii] + xp - xcrd[neigh[ll]]) * (xcrd[ii] + xp
							- xcrd[neigh[ll]]) + (ycrd[ii] + yp
							- ycrd[neigh[ll]]) * (ycrd[ii] + yp
							- ycrd[neigh[ll]]) + (zcrd[ii] + zp
							- zcrd[neigh[ll]]) * (zcrd[ii] + zp
							- zcrd[neigh[ll]]) < (radi[neigh[ll]] + srad)
							* (radi[neigh[ll]] + srad)) { // wieder
						// aendern
						// zu 1.4
						coverd = true;
					}
					++ll;
				}
				if (coverd == false) {
					int acid = myround(srad * 10.0, 2);
					Point p = Point(xcrd[ii] + xp, ycrd[ii] + yp,
							zcrd[ii] + zp, 0, acid, 0.0);
					bool hit = false;
					/*
					 * check if already similar in
					 */
					for (unsigned int os = 0; os < sps.size(); os++) {
						if (((p.x - sps[os].x) * (p.x - sps[os].x) + (p.y
								- sps[os].y) * (p.y - sps[os].y) + (p.z
								- sps[os].z) * (p.z - sps[os].z)) <= fac2) {//srad + fac) {
							hit = true;
							break;
						}
					}
					if (hit == false) {
						sps.push_back(p);
					}
				}
			}// phi
		}// costh
	}// all atoms
	return sps;
}// method calcVolume
