/*
 * SurfacePointGenerator.h
 *
 *  Created on: 19.10.2010
 *      Author: sschneider
 */

#ifndef SURFACEPOINTGENERATOR_H_
#define SURFACEPOINTGENERATOR_H_
#include "Molecules/Molecule.h"
#include "Geometry/Point.h"

class SurfacePointGenerator {
public:
	SurfacePointGenerator(Protein average, int nphi, int ncosth);
	virtual ~SurfacePointGenerator();
	vector<Point> calcVolume(float srad, float flac);
private:
	int nphi, ncosth;
//	int nphi = 55;
//	int ncosth = 40;
	static const float pi = 3.141592654;

	int natoms, iemax;
	int neigh[8000], numneh, ie[30000];//ongrid[30000],
	float xcrd[30000], ycrd[30000], zcrd[30000], srad;
	float radi[30000], csth[400], snth[400], phgh[400];
	float sasa[30000];//, sres[6000];
	float cos_phigh[400];
	float sin_phigh[400];
	double xp, yp, zp, ccdist, rr;//, ges,  gesd, gesp;
	double phigh, costh, sinth;
	bool coverd;
	int ii, jj, kk, ll, ik, idna;
};

#endif /* SURFACEPOINTGENERATOR_H_ */
