//============================================================================
// Name        : SurfacePointShrake.cpp
// Author      : Sebastian Schneider
// Version     :
// Copyright   : 
// Description : Ansi-style
//============================================================================

#include <iostream>
#include <math.h>
#include <stdlib.h>
#include "IO.h"
#include "Geometry/SurfacePoint.h"
#include "SurfacePointGenerator.h"

using namespace std;

int main(int argc, char *argv[]) {
	if (argc != 5){
	cout << "" << endl;
	cout << "" << endl;
	cout << "Not enough arguments. Use as follows" << endl;
	cout << "" << endl;
	cout << "SurfacePointsShrake myprotein.pdb size_of_small_probe size_of_big_probe" << endl;
	cout << "" << endl;
	cout << "e.g. SurfacePointsShrake myprotein.pdb 1.4 4.5" << endl;
	cout << "" << endl;
	cout << "resulting file name: raw.spt" << endl;
	cout << "" << endl;
	cout << "" << endl;
	return 0;
	}
	int nphi = 40;
	int ncosth = 25;

	Reader ready = Reader();
	Protein protein = ready.readProtein(argv[1]);
	float smallSize = atof(argv[2]);
	float bigSize = atof(argv[3]);
	float factor = 2.0;


	SurfacePointGenerator SPG = SurfacePointGenerator(protein, nphi, ncosth);
	vector<Point> small = SPG.calcVolume(smallSize, smallSize / factor);//smallSize / 2.0);
	Writer writy = Writer();
	writy.writeSurfacePoints(small, "raw.points");
	vector<Point> big = SPG.calcVolume(bigSize, 2.0);
	for (unsigned int j = 0; j < small.size(); j++) {
		small[j].init_flag = 0;
	}
	//	writy.writeSurfacePoints(small, "testor.pdb");
	/*
	 * deleting non cavity atoms
	 */
	for (unsigned int i = 0; i < big.size(); i++) {
		for (unsigned int j = 0; j < small.size(); j++) {
			if (small[j].init_flag == 10) {
				continue;
			}
			if (((big[i].x - small[j].x) * (big[i].x - small[j].x) + (big[i].y
					- small[j].y) * (big[i].y - small[j].y) + (big[i].z
					- small[j].z) * (big[i].z - small[j].z)) < (smallSize
					+ bigSize) * (smallSize + bigSize)) {
				small[j].init_flag = 10;
			}
		}
	}
	vector<Point> result;
	for (unsigned int i = 0; i < small.size(); i++) {
		if (small[i].init_flag < 10) {
			result.push_back(small[i]);
		}
	}

	//	float probeSize = 1.8;
	//	vector<Point> final = SPG.calcVolume(probeSize, 1.4);
	//	vector<Point> result2;
	//	for (unsigned int i = 0; i < final.size(); i++) {
	//		for (unsigned int j = 0; j < result.size(); j++) {
	//			float d = (final[i].x - result[j].x) * (final[i].x - result[j].x)
	//					+ (final[i].y - result[j].y) * (final[i].y - result[j].y)
	//					+ (final[i].z - result[j].z) * (final[i].z - result[j].z);
	//			if (d < (smallSize + probeSize) * (smallSize + probeSize)) {
	//				result2.push_back(final[i]);
	//			}
	//		}
	//	}

	//	writy.writeSurfacePoints(result, "small_raw.spt");
	writy.writeSurfacePoints(result, "raw.spt");
	return 0;
}
